## libc++ 3.7.0

=== CMakeLists.txt ===
#===============================================================================
# Setup Project
#===============================================================================

cmake_minimum_required(VERSION 2.8.8)

if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # Set MACOSX_RPATH=YES by default
endif()

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  project(libcxxabi)

  # Rely on llvm-config.
  set(CONFIG_OUTPUT)
  find_program(LLVM_CONFIG "llvm-config")
  if(DEFINED LLVM_PATH)
    set(LLVM_INCLUDE_DIR ${LLVM_INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_PATH ${LLVM_PATH} CACHE PATH "Path to LLVM source tree")
    set(LLVM_MAIN_SRC_DIR ${LLVM_PATH})
    set(LLVM_CMAKE_PATH "${LLVM_PATH}/cmake/modules")
  elseif(LLVM_CONFIG)
    message(STATUS "Found LLVM_CONFIG as ${LLVM_CONFIG}")
    set(CONFIG_COMMAND ${LLVM_CONFIG}
      "--includedir"
      "--prefix"
      "--src-root")
    execute_process(
      COMMAND ${CONFIG_COMMAND}
      RESULT_VARIABLE HAD_ERROR
      OUTPUT_VARIABLE CONFIG_OUTPUT
    )
    if(NOT HAD_ERROR)
      string(REGEX REPLACE
        "[ \t]*[\r\n]+[ \t]*" ";"
        CONFIG_OUTPUT ${CONFIG_OUTPUT})
    else()
      string(REPLACE ";" " " CONFIG_COMMAND_STR "${CONFIG_COMMAND}")
      message(STATUS "${CONFIG_COMMAND_STR}")
      message(FATAL_ERROR "llvm-config failed with status ${HAD_ERROR}")
    endif()

    list(GET CONFIG_OUTPUT 0 INCLUDE_DIR)
    list(GET CONFIG_OUTPUT 1 LLVM_OBJ_ROOT)
    list(GET CONFIG_OUTPUT 2 MAIN_SRC_DIR)

    set(LLVM_INCLUDE_DIR ${INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_BINARY_DIR ${LLVM_OBJ_ROOT} CACHE PATH "Path to LLVM build tree")
    set(LLVM_MAIN_SRC_DIR ${MAIN_SRC_DIR} CACHE PATH "Path to LLVM source tree")
    set(LLVM_CMAKE_PATH "${LLVM_BINARY_DIR}/share/llvm/cmake")
    set(LLVM_LIT_PATH "${LLVM_PATH}/utils/lit/lit.py")
  else()
    message(FATAL_ERROR "llvm-config not found and LLVM_MAIN_SRC_DIR not defined. "
                        "Reconfigure with -DLLVM_CONFIG=path/to/llvm-config "
                        "or -DLLVM_PATH=path/to/llvm-source-root.")
  endif()

  if(EXISTS ${LLVM_CMAKE_PATH})
    list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_PATH}")
    include("${LLVM_CMAKE_PATH}/AddLLVM.cmake")
    include("${LLVM_CMAKE_PATH}/HandleLLVMOptions.cmake")
  else()
    message(FATAL_ERROR "Not found: ${LLVM_CMAKE_PATH}")
  endif()

  set(PACKAGE_NAME libcxxabi)
  set(PACKAGE_VERSION 3.7.0svn)
  set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
  set(PACKAGE_BUGREPORT "llvm-bugs@lists.llvm.org")

  if(EXISTS ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
    set(LLVM_LIT ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
  else()
    # Seek installed Lit.
    find_program(LLVM_LIT "lit.py" ${LLVM_MAIN_SRC_DIR}/utils/lit
      DOC "Path to lit.py")
  endif()

  if(LLVM_LIT)
    # Define the default arguments to use with 'lit', and an option for the user
    # to override.
    set(LIT_ARGS_DEFAULT "-sv")
    if (MSVC OR XCODE)
      set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
    endif()
    set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}" CACHE STRING "Default options for lit")

    # On Win32 hosts, provide an option to specify the path to the GnuWin32 tools.
    if( WIN32 AND NOT CYGWIN )
      set(LLVM_LIT_TOOLS_DIR "" CACHE PATH "Path to GnuWin32 tools")
    endif()
  else()
    set(LLVM_INCLUDE_TESTS OFF)
  endif()

  set(LIBCXXABI_LIBDIR_SUFFIX "" CACHE STRING
      "Define suffix of library directory name (32/64)")

  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LIBCXXABI_LIBDIR_SUFFIX})
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LIBCXXABI_LIBDIR_SUFFIX})

  set(LIBCXXABI_BUILT_STANDALONE 1)
else()
  set(LLVM_MAIN_SRC_DIR "${CMAKE_SOURCE_DIR}" CACHE PATH "Path to LLVM source tree")
  set(LLVM_LIT "${CMAKE_SOURCE_DIR}/utils/lit/lit.py")
  set(LIBCXXABI_LIBDIR_SUFFIX ${LLVM_LIBDIR_SUFFIX})
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================

# Define options.
option(LIBCXXABI_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBCXXABI_ENABLE_PEDANTIC "Compile with pedantic enabled." ON)
option(LIBCXXABI_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBCXXABI_USE_LLVM_UNWINDER "Build and use the LLVM unwinder." OFF)
option(LIBCXXABI_ENABLE_THREADS "Build with threads enabled" ON)
set(LIBCXXABI_GCC_TOOLCHAIN "" CACHE STRING "GCC toolchain for cross compiling.")
set(LIBCXXABI_SYSROOT "" CACHE STRING "Sysroot for cross compiling.")
set(LIBCXXABI_LIBCXX_LIBRARY_PATH "" CACHE STRING "The path to libc++ library.")

# Default to building a shared library so that the default options still test
# the libc++abi that is being built. There are two problems with testing a
# static libc++abi. In the case of a standalone build, the tests will link the
# system's libc++, which might not have been built against our libc++abi. In the
# case of an in tree build, libc++ will prefer a dynamic libc++abi from the
# system over a static libc++abi from the output directory.
option(LIBCXXABI_ENABLE_SHARED "Build libc++abi as a shared library." ON)
option(LIBCXXABI_ENABLE_STATIC "Build libc++abi as a static library." ON)

if (NOT LIBCXXABI_ENABLE_SHARED AND NOT LIBCXXABI_ENABLE_STATIC)
  message(FATAL_ERROR "libc++abi must be built as either a shared or static library.")
endif()

find_path(
  LIBCXXABI_LIBCXX_INCLUDES
  vector
  PATHS ${LIBCXXABI_LIBCXX_INCLUDES}
        ${LIBCXXABI_LIBCXX_PATH}/include
        ${CMAKE_BINARY_DIR}/${LIBCXXABI_LIBCXX_INCLUDES}
        ${LLVM_MAIN_SRC_DIR}/projects/libcxx/include
        ${LLVM_INCLUDE_DIR}/c++/v1
  )

set(LIBCXXABI_LIBCXX_INCLUDES "${LIBCXXABI_LIBCXX_INCLUDES}" CACHE PATH
    "Specify path to libc++ includes." FORCE)

find_path(
  LIBCXXABI_LIBCXX_PATH
  test/libcxx/__init__.py
  PATHS ${LIBCXXABI_LIBCXX_PATH}
        ${LIBCXXABI_LIBCXX_INCLUDES}/../
        ${LLVM_MAIN_SRC_DIR}/projects/libcxx/
  NO_DEFAULT_PATH
  )

if (LIBCXXABI_LIBCXX_PATH STREQUAL "LIBCXXABI_LIBCXX_PATH-NOTFOUND")
  message(WARNING "LIBCXXABI_LIBCXX_PATH was not specified and couldn't be infered.")
  set(LIBCXXABI_LIBCXX_PATH "")
endif()

set(LIBCXXABI_LIBCXX_PATH "${LIBCXXABI_LIBCXX_PATH}" CACHE PATH
    "Specify path to libc++ source." FORCE)

#===============================================================================
# Configure System
#===============================================================================

# Add path for custom modules
set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  ${CMAKE_MODULE_PATH}
  )

# Configure compiler.
include(config-ix)

set(LIBCXXABI_COMPILER    ${CMAKE_CXX_COMPILER})
set(LIBCXXABI_SOURCE_DIR  ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBCXXABI_BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR})
set(LIBCXXABI_LIBRARY_DIR ${CMAKE_BINARY_DIR}/lib${LIBCXXABI_LIBDIR_SUFFIX})

#===============================================================================
# Setup Compiler Flags
#===============================================================================

# Get required flags.
macro(append_if list condition var)
  if (${condition})
    list(APPEND ${list} ${var})
  endif()
endmacro()

set(LIBCXXABI_C_FLAGS "")
set(LIBCXXABI_CXX_FLAGS "")
set(LIBCXXABI_COMPILE_FLAGS "")
set(LIBCXXABI_LINK_FLAGS "")


if (LIBCXXABI_HAS_NOSTDINCXX_FLAG)
  list(APPEND LIBCXXABI_COMPILE_FLAGS -nostdinc++)
  # Remove -stdlib flags to prevent them from causing an unused flag warning.
  string(REPLACE "-stdlib=libc++" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  string(REPLACE "-stdlib=libstdc++" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
endif()


append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WERROR_FLAG -Werror=return-type)

# Get warning flags
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_W_FLAG -W)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WALL_FLAG -Wall)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WCHAR_SUBSCRIPTS_FLAG -Wchar-subscripts)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WCONVERSION_FLAG -Wconversion)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WMISMATCHED_TAGS_FLAG -Wmismatched-tags)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WMISSING_BRACES_FLAG -Wmissing-braces)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WNEWLINE_EOF_FLAG -Wnewline-eof)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WNO_UNUSED_FUNCTION_FLAG -Wno-unused-function)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSHADOW_FLAG -Wshadow)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSHORTEN_64_TO_32_FLAG -Wshorten-64-to-32)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSIGN_COMPARE_FLAG -Wsign-compare)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSIGN_CONVERSION_FLAG -Wsign-conversion)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSTRICT_ALIASING_FLAG -Wstrict-aliasing=2)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WSTRICT_OVERFLOW_FLAG -Wstrict-overflow=4)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WUNUSED_PARAMETER_FLAG -Wunused-parameter)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WUNUSED_VARIABLE_FLAG -Wunused-variable)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WWRITE_STRINGS_FLAG -Wwrite-strings)
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WUNDEF_FLAG -Wundef)

if (LIBCXXABI_ENABLE_WERROR)
  append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WERROR_FLAG -Werror)
  append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WX_FLAG -WX)
else()
  append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_WNO_ERROR_FLAG -Wno-error)
  append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_NO_WX_FLAG -WX-)
endif()
if (LIBCXXABI_ENABLE_PEDANTIC)
  append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_PEDANTIC_FLAG -pedantic)
endif()

# Get feature flags.
# Exceptions
# Catches C++ exceptions only and tells the compiler to assume that extern C
# functions never throw a C++ exception.
append_if(LIBCXXABI_CXX_FLAGS LIBCXXABI_HAS_FSTRICT_ALIASING_FLAG -fstrict-aliasing)
append_if(LIBCXXABI_CXX_FLAGS LIBCXXABI_HAS_EHSC_FLAG -EHsc)

append_if(LIBCXXABI_C_FLAGS LIBCXXABI_HAS_FUNWIND_TABLES -funwind-tables)

# Assert
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (LIBCXXABI_ENABLE_ASSERTIONS)
  # MSVC doesn't like _DEBUG on release builds. See PR 4379.
  if (NOT MSVC)
    list(APPEND LIBCXXABI_COMPILE_FLAGS -D_DEBUG)
  endif()
  # On Release builds cmake automatically defines NDEBUG, so we
  # explicitly undefine it:
  if (uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBCXXABI_COMPILE_FLAGS -UNDEBUG)
  endif()
else()
  if (NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBCXXABI_COMPILE_FLAGS -DNDEBUG)
  endif()
endif()
# Static library
if (NOT LIBCXXABI_ENABLE_SHARED)
  list(APPEND LIBCXXABI_COMPILE_FLAGS -D_LIBCPP_BUILD_STATIC)
endif()

if (NOT LIBCXXABI_ENABLE_THREADS)
  add_definitions(-DLIBCXXABI_HAS_NO_THREADS=1)
endif()

# This is the _ONLY_ place where add_definitions is called.
if (MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

# Define LIBCXXABI_USE_LLVM_UNWINDER for conditional compilation.
if (LIBCXXABI_USE_LLVM_UNWINDER OR LLVM_NATIVE_ARCH MATCHES ARM)
  add_definitions(-DLIBCXXABI_USE_LLVM_UNWINDER=1)
endif()

append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_TARGET_TRIPLE
          "-target ${LIBCXXABI_TARGET_TRIPLE}")
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_GCC_TOOLCHAIN
         "-gcc-toolchain ${LIBCXXABI_GCC_TOOLCHAIN}")
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_SYSROOT
          "--sysroot ${LIBCXXABI_SYSROOT}")
string(REPLACE ";" " " LIBCXXABI_CXX_FLAGS "${LIBCXXABI_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LIBCXXABI_CXX_FLAGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LIBCXXABI_C_FLAGS}")

#===============================================================================
# Setup Source Code
#===============================================================================

=== include/CMakeLists.txt ===
if (NOT LIBCXX_INSTALL_SUPPORT_HEADERS)
  set(LIBCXX_SUPPORT_HEADER_PATTERN PATTERN "support" EXCLUDE)
endif()
set(LIBCXX_HEADER_PATTERN
  PATTERN "*"
  PATTERN "CMakeLists.txt" EXCLUDE
  PATTERN ".svn" EXCLUDE
  ${LIBCXX_SUPPORT_HEADER_PATTERN}
  )

file(COPY .
  DESTINATION "${CMAKE_BINARY_DIR}/include/c++/v1"
  FILES_MATCHING
  ${LIBCXX_HEADER_PATTERN}
  )

if (LIBCXX_INSTALL_HEADERS)
  install(DIRECTORY .
    DESTINATION include/c++/v1
    FILES_MATCHING
    ${LIBCXX_HEADER_PATTERN}
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )
endif()

=== lib/CMakeLists.txt ===
set(LIBCXX_LIB_CMAKEFILES_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}"  PARENT_SCOPE)

# Get sources
file(GLOB LIBCXX_SOURCES ../src/*.cpp)
if(WIN32)
  file(GLOB LIBCXX_WIN32_SOURCES ../src/support/win32/*.cpp)
  list(APPEND LIBCXX_SOURCES ${LIBCXX_WIN32_SOURCES})
elseif("${CMAKE_SYSTEM_NAME}" STREQUAL "SunOS")
  file(GLOB LIBCXX_SOLARIS_SOURCES ../src/support/solaris/*.c)
  list(APPEND LIBCXX_SOURCES ${LIBCXX_SOLARIS_SOURCES})
endif()

# Add all the headers to the project for IDEs.
if (MSVC_IDE OR XCODE)
  file(GLOB_RECURSE LIBCXX_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../include/*)
  if(WIN32)
    file( GLOB LIBCXX_WIN32_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../include/support/win32/*.h)
    list(APPEND LIBCXX_HEADERS ${LIBCXX_WIN32_HEADERS})
  endif()
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  if (MSVC_IDE)
    source_group("Header Files" FILES ${LIBCXX_HEADERS})
  endif()
endif()

if (LIBCXX_ENABLE_SHARED)
  add_library(cxx SHARED
    ${LIBCXX_SOURCES}
    ${LIBCXX_HEADERS}
    )
else()
  add_library(cxx STATIC
    ${LIBCXX_SOURCES}
    ${LIBCXX_HEADERS}
    )
endif()

#if LIBCXX_CXX_ABI_LIBRARY_PATH is defined we want to add it to the search path.
if (DEFINED LIBCXX_CXX_ABI_LIBRARY_PATH)
  target_link_libraries(cxx "-L${LIBCXX_CXX_ABI_LIBRARY_PATH}")
endif()

if (DEFINED LIBCXX_CXX_ABI_DEPS)
  add_dependencies(cxx LIBCXX_CXX_ABI_DEPS)
endif()

set(libraries "")
if (LIBCXX_ENABLE_STATIC_ABI_LIBRARY)
    # TODO(ericwf): Remove these GNU specific linker flags and let CMake do the
    # configuration. This will be more portable.
    list(APPEND libraries "-Wl,--whole-archive" "-Wl,-Bstatic")
    list(APPEND libraries "${LIBCXX_CXX_ABI_LIBRARY}")
    list(APPEND libraries "-Wl,-Bdynamic" "-Wl,--no-whole-archive")
else()
    list(APPEND libraries "${LIBCXX_CXX_ABI_LIBRARY}")
endif()

# Generate library list.
append_if(libraries LIBCXX_HAS_PTHREAD_LIB pthread)
append_if(libraries LIBCXX_HAS_C_LIB c)
append_if(libraries LIBCXX_HAS_M_LIB m)
append_if(libraries LIBCXX_HAS_RT_LIB rt)
append_if(libraries LIBCXX_HAS_GCC_S_LIB gcc_s)

if (LIBCXX_COVERAGE_LIBRARY)
  target_link_libraries(cxx ${LIBCXX_COVERAGE_LIBRARY})
endif()
target_link_libraries(cxx ${libraries})


# Setup flags.
append_if(LIBCXX_COMPILE_FLAGS LIBCXX_HAS_FPIC_FLAG -fPIC)
append_if(LIBCXX_LINK_FLAGS LIBCXX_HAS_NODEFAULTLIBS_FLAG -nodefaultlibs)

if ( APPLE AND (LIBCXX_CXX_ABI_LIBNAME STREQUAL "libcxxabi" OR
                LIBCXX_CXX_ABI_LIBNAME STREQUAL "none"))
  if (NOT DEFINED LIBCXX_LIBCPPABI_VERSION)
    set(LIBCXX_LIBCPPABI_VERSION "2")
  endif()

  if ( CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6" )
    list(APPEND LIBCXX_COMPILE_FLAGS "-U__STRICT_ANSI__")
    list(APPEND LIBCXX_LINK_FLAGS
      "-compatibility_version 1"
      "-current_version 1"
      "-install_name /usr/lib/libc++.1.dylib"
      "-Wl,-reexport_library,/usr/lib/libc++abi.dylib"
      "-Wl,-unexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++unexp.exp"
      "/usr/lib/libSystem.B.dylib")
  else()
    if ( ${CMAKE_OSX_SYSROOT} )
      list(FIND ${CMAKE_OSX_ARCHITECTURES} "armv7" OSX_HAS_ARMV7)
      if (OSX_HAS_ARMV7)
        set(OSX_RE_EXPORT_LINE
          "${CMAKE_OSX_SYSROOT}/usr/lib/libc++abi.dylib"
          "-Wl,-reexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++sjlj-abi.exp")
      else()
        set(OSX_RE_EXPORT_LINE
          "-Wl,-reexport_library,${CMAKE_OSX_SYSROOT}/usr/lib/libc++abi.dylib")
      endif()
    else()
      set (OSX_RE_EXPORT_LINE "/usr/lib/libc++abi.dylib -Wl,-reexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++abi${LIBCXX_LIBCPPABI_VERSION}.exp")
    endif()

    list(APPEND LIBCXX_LINK_FLAGS
      "-compatibility_version 1"
      "-install_name /usr/lib/libc++.1.dylib"
      "-Wl,-unexported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libc++unexp.exp"
      "${OSX_RE_EXPORT_LINE}"
      "-Wl,-force_symbols_not_weak_list,${CMAKE_CURRENT_SOURCE_DIR}/notweak.exp"
      "-Wl,-force_symbols_weak_list,${CMAKE_CURRENT_SOURCE_DIR}/weak.exp")
  endif()
endif()

string(REPLACE ";" " " LIBCXX_COMPILE_FLAGS "${LIBCXX_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBCXX_LINK_FLAGS "${LIBCXX_LINK_FLAGS}")

set_target_properties(cxx
  PROPERTIES
    COMPILE_FLAGS "${LIBCXX_COMPILE_FLAGS}"
    LINK_FLAGS    "${LIBCXX_LINK_FLAGS}"
    OUTPUT_NAME   "c++"
    VERSION       "1.0"
    SOVERSION     "1"
  )

install(TARGETS cxx
  LIBRARY DESTINATION lib${LIBCXX_LIBDIR_SUFFIX}
  ARCHIVE DESTINATION lib${LIBCXX_LIBDIR_SUFFIX}
  )

=== src/CMakeLists.txt ===
# Get sources
set(LIBCXXABI_SOURCES
  abort_message.cpp
  cxa_aux_runtime.cpp
  cxa_default_handlers.cpp
  cxa_demangle.cpp
  cxa_exception.cpp
  cxa_exception_storage.cpp
  cxa_guard.cpp
  cxa_handlers.cpp
  cxa_new_delete.cpp
  cxa_personality.cpp
  cxa_unexpected.cpp
  cxa_vector.cpp
  cxa_virtual.cpp
  exception.cpp
  private_typeinfo.cpp
  stdexcept.cpp
  typeinfo.cpp
)

if (UNIX AND NOT (APPLE OR CYGWIN))
  list(APPEND LIBCXXABI_SOURCES cxa_thread_atexit.cpp)
endif()

set(LIBCXXABI_HEADERS ../include/cxxabi.h)

# Add all the headers to the project for IDEs.
if (MSVC_IDE OR XCODE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  if (MSVC_IDE)
    source_group("Header Files" FILES ${LIBCXXABI_HEADERS})
  endif()
endif()

include_directories("${LIBCXXABI_LIBCXX_INCLUDES}")

if (LIBCXXABI_HAS_CXA_THREAD_ATEXIT_IMPL)
  add_definitions(-DHAVE___CXA_THREAD_ATEXIT_IMPL)
endif()

# Generate library list.
set(libraries ${LIBCXXABI_CXX_ABI_LIBRARIES})
append_if(libraries LIBCXXABI_HAS_C_LIB c)
if (LIBCXXABI_ENABLE_THREADS)
  append_if(libraries LIBCXXABI_HAS_PTHREAD_LIB pthread)
endif()

if (LIBCXXABI_USE_LLVM_UNWINDER)
  list(APPEND libraries unwind)
else()
  append_if(libraries LIBCXXABI_HAS_GCC_EH_LIB gcc_eh)
endif()

# Setup flags.
append_if(LIBCXXABI_COMPILE_FLAGS LIBCXXABI_HAS_FPIC_FLAG -fPIC)
append_if(LIBCXXABI_LINK_FLAGS LIBCXXABI_HAS_NODEFAULTLIBS_FLAG -nodefaultlibs)

set(LIBCXXABI_SHARED_LINK_FLAGS)

if ( APPLE )
  if ( CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6" )
    list(APPEND LIBCXXABI_COMPILE_FLAGS "-U__STRICT_ANSI__")
    list(APPEND LIBCXXABI_SHARED_LINK_FLAGS
      "-compatibility_version 1"
      "-current_version 1"
      "-install_name /usr/lib/libc++abi.1.dylib")
    list(APPEND LIBCXXABI_LINK_FLAGS
        "/usr/lib/libSystem.B.dylib")
  else()
    list(APPEND LIBCXXABI_SHARED_LINK_FLAGS
      "-compatibility_version 1"
      "-install_name /usr/lib/libc++abi.1.dylib")
  endif()
endif()

string(REPLACE ";" " " LIBCXXABI_COMPILE_FLAGS "${LIBCXXABI_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBCXXABI_LINK_FLAGS "${LIBCXXABI_LINK_FLAGS}")
string(REPLACE ";" " " LIBCXXABI_SHARED_LINK_FLAGS "${LIBCXXABI_SHARED_LINK_FLAGS}")

# Add a object library that contains the compiled source files.
add_library(cxxabi_objects OBJECT ${LIBCXXABI_SOURCES} ${LIBCXXABI_HEADERS})

set_target_properties(cxxabi_objects
  PROPERTIES
    COMPILE_FLAGS "${LIBCXXABI_COMPILE_FLAGS}"
  )

set(LIBCXXABI_TARGETS)

# Build the shared library.
if (LIBCXXABI_ENABLE_SHARED)
  add_library(cxxabi_shared SHARED $<TARGET_OBJECTS:cxxabi_objects>)
  target_link_libraries(cxxabi_shared ${libraries})
  set_target_properties(cxxabi_shared
    PROPERTIES
      LINK_FLAGS    "${LIBCXXABI_LINK_FLAGS} ${LIBCXXABI_SHARED_LINK_FLAGS}"
      OUTPUT_NAME   "c++abi"
      VERSION       "1.0"
      SOVERSION     "1"
    )
  list(APPEND LIBCXXABI_TARGETS "cxxabi_shared")
endif()

# Build the static library.
if (LIBCXXABI_ENABLE_STATIC)
  add_library(cxxabi_static STATIC $<TARGET_OBJECTS:cxxabi_objects>)
  target_link_libraries(cxxabi_static ${libraries})
  set_target_properties(cxxabi_static
    PROPERTIES
      LINK_FLAGS    "${LIBCXXABI_LINK_FLAGS}"
      OUTPUT_NAME   "c++abi"
  )
  list(APPEND LIBCXXABI_TARGETS "cxxabi_static")
endif()

# Add a meta-target for both libraries.
add_custom_target(cxxabi DEPENDS ${LIBCXXABI_TARGETS})

install(TARGETS ${LIBCXXABI_TARGETS}
  LIBRARY DESTINATION lib${LIBCXXABI_LIBDIR_SUFFIX}
  ARCHIVE DESTINATION lib${LIBCXXABI_LIBDIR_SUFFIX}
  )

=== test/CMakeLists.txt ===
macro(pythonize_bool var)
  if (${var})
    set(${var} True)
  else()
    set(${var} False)
  endif()
endmacro()

set(LIT_EXECUTABLE "" CACHE FILEPATH "Path to LLVM's llvm-lit.")

if(LIBCXX_BUILT_STANDALONE)
  # Make sure we can use the console pool for recent cmake and ninja > 1.5
  if(CMAKE_VERSION VERSION_LESS 3.1.20141117)
    set(cmake_3_2_USES_TERMINAL)
  else()
    set(cmake_3_2_USES_TERMINAL USES_TERMINAL)
  endif()
else()
  include(FindPythonInterp)
  if(PYTHONINTERP_FOUND)
    set(LIT_EXECUTABLE
        ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/utils/lit/lit.py)
  else()
    message(WARNING "Could not find Python, cannot set LIT_EXECUTABLE.")
  endif()
endif()

if (LIT_EXECUTABLE)
  set(LIT_ARGS_DEFAULT "-sv --show-unsupported --show-xfail")
  if (MSVC OR XCODE)
    set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
  endif()
  set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}"
      CACHE STRING "Default options for lit")
  set(LIT_ARGS "${LLVM_LIT_ARGS}")
  separate_arguments(LIT_ARGS)

  set(LIBCXX_LIT_VARIANT "libcxx" CACHE STRING
      "Configuration variant to use for LIT.")

  pythonize_bool(LIBCXX_ENABLE_EXCEPTIONS)
  pythonize_bool(LIBCXX_ENABLE_RTTI)
  pythonize_bool(LIBCXX_ENABLE_SHARED)
  pythonize_bool(LIBCXX_BUILD_32_BITS)
  pythonize_bool(LIBCXX_ENABLE_GLOBAL_FILESYSTEM_NAMESPACE)
  pythonize_bool(LIBCXX_ENABLE_STDIN)
  pythonize_bool(LIBCXX_ENABLE_STDOUT)
  pythonize_bool(LIBCXX_ENABLE_THREADS)
  pythonize_bool(LIBCXX_ENABLE_THREAD_UNSAFE_C_FUNCTIONS)
  pythonize_bool(LIBCXX_ENABLE_MONOTONIC_CLOCK)
  pythonize_bool(LIBCXX_GENERATE_COVERAGE)
  pythonize_bool(LIBCXXABI_USE_LLVM_UNWINDER)

  # The tests shouldn't link to any ABI library when it has been linked into
  # libc++ statically.
  if (LIBCXX_ENABLE_STATIC_ABI_LIBRARY)
    set(LIBCXX_CXX_ABI_LIBNAME "none")
  endif()
  set(LIBCXX_TARGET_INFO "libcxx.test.target_info.LocalTI" CACHE STRING
      "TargetInfo to use when setting up test environment.")
  set(LIBCXX_EXECUTOR "None" CACHE STRING
      "Executor to use when running tests.")

  set(AUTO_GEN_COMMENT "## Autogenerated by libcxx configuration.\n# Do not edit!")

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg
    @ONLY)

  add_custom_target(check-libcxx
    COMMAND ${LIT_EXECUTABLE}
            ${LIT_ARGS}
            ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS cxx
    COMMENT "Running libcxx tests"
    ${cmake_3_2_USES_TERMINAL})

  if (LIBCXX_GENERATE_COVERAGE)
    include(CodeCoverage)
    set(output_dir "${CMAKE_CURRENT_BINARY_DIR}/coverage")
    set(capture_dirs "${LIBCXX_LIB_CMAKEFILES_DIR}/cxx.dir/;${CMAKE_CURRENT_BINARY_DIR}")
    set(extract_dirs "${LIBCXX_SOURCE_DIR}/include;${LIBCXX_SOURCE_DIR}/src")
    setup_lcov_test_target_coverage("cxx" "${output_dir}" "${capture_dirs}" "${extract_dirs}")
  endif()
else()
  message(WARNING
          "LIT_EXECUTABLE not set, no check-libcxx target will be available!")
endif()

=== debian/changelog ===
libc++ (3.7.0-1ubuntu0.1) xenial; urgency=medium

  * Fix error int the string header in c++11 mode (LP: #1610168).

 -- Sergey Vidyuk <Sir-VestniK@yandex.ru>  Sat, 24 Jun 2017 18:09:34 +0700

libc++ (3.7.0-1) unstable; urgency=medium

  * New upstrem release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 06 Sep 2015 12:02:37 +0200

libc++ (3.6.2-1) unstable; urgency=medium

  * New upstream release
  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 03 Aug 2015 14:23:53 +0200

libc++ (3.6-1~exp1) experimental; urgency=medium

  * New upstream release
  * Add support for kfreebsd. Thanks to Jan Henke (Closes: #780106)
  * Standards-Version updated to 3.9.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Mar 2015 18:48:20 +0100

=== debian/control ===
Source: libc++
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
Standards-Version: 3.9.6
Section: libs
Homepage: http://libcxx.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/libcxx/trunk/

Package: libc++1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: clang
Description: LLVM C++ Standard library
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}, libc++-helpers
Provides: libstdc++-dev
Description: LLVM C++ Standard library (development files)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-test
Section: libs
Architecture: any
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Replaces: libc++-src (<< 1.0~svn199600-1)
Breaks: libc++-src (<< 1.0~svn199600-1)
Description: LLVM C++ Standard library (test cases)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the test cases of libc++ library.

Package: libc++abi1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LLVM low level support for a standard C++ library
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM low level support for a standard C++ library (development files)
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-test
Section: libs
Architecture: any
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Replaces: libc++abi-src (<< 1.0~svn199600-1)
Breaks: libc++abi-src (<< 1.0~svn199600-1)
Description: libc++abi test cases
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .
 Test cases of libc++abi library.


Package: libc++-helpers
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: libc++-dev (<< 1.0~svn199600-1)
Breaks: libc++-dev (<< 1.0~svn199600-1)
Description: LLVM C++ Standard library - build helpers
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the build helpers (clang++-libc++, etc)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

%:
	dh $@

override_dh_auto_clean:
	cd libcxxabi/test; \
		rm -f a.out
	cd libcxxabi/lib; \
		rm -f libc++abi.a libc++abi.so.1.0 libc++abi.so libc++abi.so.1 *.o
	cd libcxx/lib; \
		rm -f libc++.a libc++.so.1.0 libc++.so libc++.so.1.0 libc++.so.1 *.o

override_dh_auto_build:
	cd libcxxabi/lib && \
		rm -f libc++abi.so libc++abi.so.1 && \
		./buildit && \
		ln -s libc++abi.so.1.0 libc++abi.so && \
		ln -s libc++abi.so.1.0 libc++abi.so.1

	cd libcxx/lib && \
		rm -f libc++.so libc++.so.1 && \
		./buildit && \
		rm -f libc++.so libc++.so.1 && \
		ln -s libc++.so.1.0 libc++.so && \
		ln -s libc++.so.1.0 libc++.so.1

.PHONY: get-orig-source
get-orig-source:
	sh debian/libc++-get-orig-source.sh $(SRC_VERSION)

## libc++ 3.9.1

=== debian/changelog ===
libc++ (3.9.1-2) unstable; urgency=medium

  * Silent a few tests on some archs to make the testsuite green.
    The testsuites are more than 5000 tests. We can live with ignoring a few
    tests.
    (Closes: #823058) even if it was a different issue
  * Remove useless libc++1.postinst, libc++1.postrm, libc++abi1.postinst
    and libc++abi1.postrm
  * Add debian/watch to detect new upstream release (but should
    not be used to retrieve sources)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 10 Jan 2017 16:45:20 +0100

libc++ (3.9.1-1) unstable; urgency=medium

  * New upstream release
  * Fix the FTBFS with dpkg-buildpackage -A (Closes: #849570)
    Thanks to Santiago Vila for the patch

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Dec 2016 11:09:43 +0100

libc++ (3.9.0-3) unstable; urgency=medium

  * Team upload
  * Add missing Replaces dependency to libc++abi-dev (Closes: #843027)
  * Fix arm EHABI code to allow exceptions on armhf
  * Fix some unit test on different architectures

 -- Pauli <suokkos@gmail.com>  Thu, 03 Nov 2016 23:49:34 +0200

libc++ (3.9.0-2) unstable; urgency=medium

  * Team upload
  * Fix libc++abi-dev header paths (Closes: #800492, #806692)
  * Use cmake build system that should be easier to port to newer versions
  * Build libc++experimental.a for c++17 features with unstable ABI
  * Remove hardcoded ldconfig invocations from postinst&postrm
  * Bugs fixed with 3.9.0 release (Closes: #808086, #801303, #841594)

  [ Sylvestre Ledru ]
  * Remove pyc from the deb packages
  * Fix the copyright file

 -- Pauli <suokkos@gmail.com>  Tue, 01 Nov 2016 17:27:02 +0200

libc++ (3.9.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release (Closes: #837608)

  [ Sylvestre Ledru ]
  * Standards-Version updated to 3.9.8

 -- Pauli <suokkos@gmail.com>  Mon, 31 Oct 2016 12:56:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: libc++
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0.0), cmake, clang-3.9 (>= 1:3.9-5), dh-exec, llvm-3.9-tools,
+ locales-all
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://libcxx.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
@@ -92,6 +92,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
+Replaces: libc++-dev (<< 3.9.0-3)
+Breaks: lic++-dev (<< 3.9.0-3)
 Description: LLVM low level support for a standard C++ library (development files)
  libc++abi is a new implementation of low level support for a standard C++
  library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

BUILDDIR := build
CXX_DEB_INST := $(CURDIR)/debian/cxx/
CXXABI_DEB_INST := $(CURDIR)/debian/abi/

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
# dpkg-buildflags prevents ::operator new global overloading if used for libc++
#LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS :=
DEB_HOST_ARCH       = $(shell dpkg-architecture -qDEB_HOST_ARCH)

EXCEPTIONS :=ON
# Exceptions don't seem to work on s390x. Exceptions disabled because I have
# no idea what ABI specifications tells about s390x exception handling.
ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
EXCEPTIONS :=OFF
endif

CLANG_VERSION := 3.9
CMAKE ?= $(shell which cmake)

SHARED_CMAKE_OPTIONS := \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DLLVM_CONFIG=$(shell which llvm-config-$(CLANG_VERSION)) \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_AR=$(shell which llvm-ar-$(CLANG_VERSION)) \
	-DCMAKE_RANLIB=$(shell which llvm-ranlib-$(CLANG_VERSION)) \
	-DCMAKE_CXX_COMPILER=$(shell which clang++-$(CLANG_VERSION)) \
	-DCMAKE_C_COMPILER=$(shell which clang-$(CLANG_VERSION)) \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_MODULE_LINKER_FLAGS="$(LDFLAGS)"

CXXABI_CMAKE_OPTIONS := \
	-DLIBCXXABI_LIBCXX_PATH=$(abspath libcxx) \
	-DLIBCXXABI_LIBCXX_LIBRARY_PATH=$(abspath libcxx/$(BUILDDIR)/lib) \
	-DLIBCXXABI_ENABLE_EXCEPTIONS=$(EXCEPTIONS) \
	-DLLVM_ENABLE_RTTI=ON

CXX_CMAKE_OPTIONS := \
	-DLIBCXX_CXX_ABI=libcxxabi \
	-DLIBCXX_CXX_ABI_INCLUDE_PATHS=$(abspath libcxxabi/include) \
	-DLIBCXX_CXX_ABI_LIBRARY_PATH=$(abspath	libcxxabi/$(BUILDDIR)/lib) \
	-DLIBCXX_ENABLE_EXCEPTIONS=$(EXCEPTIONS) \
	-DLIBCXX_INSTALL_EXPERIMENTAL_LIBRARY=ON

%:
	dh $@

override_dh_auto_clean:
	rm -rf libcxxabi/$(BUILDDIR) libcxx/$(BUILDDIR) $(CXX_DEB_INST) $(CXXABI_DEB_INST)
	find -name *.pyc -delete

override_dh_auto_build:
	mkdir -p libcxxabi/$(BUILDDIR) && \
	cd libcxxabi/$(BUILDDIR) && \
		$(CMAKE) .. $(SHARED_CMAKE_OPTIONS) $(CXXABI_CMAKE_OPTIONS) && \
		make $(NJOBS) VERBOSE=1
	mkdir -p libcxx/$(BUILDDIR) && \
	cd libcxx/$(BUILDDIR) && \
		$(CMAKE) .. $(SHARED_CMAKE_OPTIONS) $(CXX_CMAKE_OPTIONS) && \
		make $(NJOBS) VERBOSE=1

override_dh_auto_install:
	make -C libcxxabi/$(BUILDDIR) install DESTDIR=$(CXXABI_DEB_INST)
	make -C libcxx/$(BUILDDIR) install DESTDIR=$(CXX_DEB_INST)
	mkdir -p $(CXXABI_DEB_INST)/usr/include/c++/v1/
	mv $(CXX_DEB_INST)/usr/include/c++/v1/*cxxabi*.h $(CXXABI_DEB_INST)/usr/include/c++/v1/

override_dh_install-arch:
	dh_install
	find debian/libc++-test -name *.pyc -delete
	find debian/libc++abi-test -name *.pyc -delete

# python is unstable on s390x
ifeq (,$(filter $(DEB_HOST_ARCH),s390x))
ifeq (,$(filter nocheck,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
override_dh_auto_test:
	make -C libcxxabi/$(BUILDDIR) check-libcxxabi
	make -C libcxx/$(BUILDDIR) check-libcxx
endif
endif

.PHONY: get-orig-source
get-orig-source:
	sh debian/libc++-get-orig-source.sh $(SRC_VERSION)
